// Copyright (C) 2001 - 2002 - R.Coisson & G. Vernizzi, Parma University
// Copyright (C) X. K. Yang
// Copyright (C) 2010 - 2012 - N. O. Strelkov, NRU MPEI
// Copyright (C) 2011 - DIGITEO - Michael Baudin
//
// This file must be used under the terms of the GPL Version 2
// http://www.gnu.org/licenses/gpl-2.0.html

//confroq4.sce
//comparison of modes with q=0 and q=8, even & odd
h=scf();
n=3;
m=2;
subplot(2,2,1)
mathieu_elliptical('e',n,m,0.1);
set(gca(),"isoview","on");
set(gca(),"data_bounds",[-20,20,-20,20]);
set(gca(),"tight_limits","on");
set(gca(),"rotation_angles",[0,90]);
xtitle('Even mode n=3, m=2, q=0.1');

subplot(2,2,2)
mathieu_elliptical('e',n,m,8);
set(gca(),"isoview","on");
set(gca(),"data_bounds",[-2.2,2.2,-2.2,2.2])
set(gca(),"tight_limits","on");
set(gca(),"rotation_angles",[0,90]);
xtitle('Even mode n=3, m=2, q=8');

subplot(2,2,3)
mathieu_elliptical('o',n,m,0.1);
set(gca(),"isoview","on");
set(gca(),"data_bounds",[-20,20,-20,20]);
set(gca(),"tight_limits","on");
set(gca(),"rotation_angles",[0,90]);
xtitle('Odd mode n=3, m=2, q=0.1');

subplot(2,2,4)
mathieu_elliptical('o',n,m,8);
set(gca(),"isoview","on");
set(gca(),"data_bounds",[-2.2,2.2,-2.2,2.2])
set(gca(),"tight_limits","on");
set(gca(),"rotation_angles",[0,90]);
xtitle('Odd mode n=3, m=2, q=8');
