// Copyright (C) 2001 - 2002 - R.Coisson & G. Vernizzi, Parma University
// Copyright (C) X. K. Yang
// Copyright (C) 2010 - 2012 - N. O. Strelkov, NRU MPEI
// Copyright (C) 2011 - DIGITEO - Michael Baudin
//
// This file must be used under the terms of the GPL Version 2
// http://www.gnu.org/licenses/gpl-2.0.html

// ellissi.sci
// 3D plot of a mode with elliptical boundary conditions
// n = radial order 
// m = angular order (ce, se)
// q = ... modifies ellipticity (q~=0)
// also outputs radial zeros and ellipse apect ratio
h=scf();
ty='e';
if ty=='e',tr='Ce', ta='ce', end
if ty=='o', tr='Se',ta='se', end
q=8;
n=3;
//mr=4;
m=3;
eta=0:.1:2*%pi+.2;										// argument of angular function: 0 to 2*pi
u0=0.01:.01:2.9;									// range radiale di prova
f0=mathieu_mathieu(tr,m,u0,q)>0;
f1=bool2s(f0);
f2=diff(f1);
sol=u0(find(f2~=0))									// find zeroes of radial function
xi=0:.01:sol(n);										//arg. corresp. to n-th zero
f=mathieu_mathieu(tr,m,xi,q);
g=mathieu_mathieu(ta,m,eta,q);
[x,y]=mathieu_ell2cart(xi,eta,1);								// conv. to Cartesian coord 
// 1 e` semi-dist. fra fuochi
rapportoassi=max(max(x))/max(max(y))
zeta=f*g';
mass=max(max(zeta));
xset("colormap",jetcolormap(128));					//set the colormap
surf(x,y,zeta/mass*max(max(x)),"facecol","interp");         // *q per dimensionare z
e=gce();
e.color_mode=-1;									//set the color mode, vanish the mesh
um=min(zeta/mass*max(max(x)));
uM=max(zeta/mass*max(max(x)));
colorbar(um,uM)						//show the colorbar using min and max values of yy
set(gca(),"isoview","on");							//set the axises x and y equal
//contour(x,y,40/q*f*g',40)

xtitle('3D plot of a mode with elliptical boundary conditions (m=3, n=3, q=8)');
